package com.aeqweb.http;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

// More infromation at: https://www.aeq-web.com/android-http-request-mit-einem-asynctask/?ref=androidstudio

public class MainActivity extends AppCompatActivity {

    String SERVER_URL = "http://testserver.aeq-web.com/android_http_request";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        new HttpTask().execute(SERVER_URL);

        Button reload = (Button) findViewById(R.id.button);
        reload.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new HttpTask().execute(SERVER_URL);
            }
        });
    }

    private class HttpTask extends AsyncTask<String, Void, String> {
        @Override
        protected String doInBackground(String... strURLs) {
            URL url = null;
            HttpURLConnection conn = null;
            try {
                url = new URL(strURLs[0]);
                conn = (HttpURLConnection) url.openConnection();
                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {
                    InputStream in = url.openStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(in));
                    StringBuilder result = new StringBuilder();
                    String line;
                    while ((line = reader.readLine()) != null) {
                        result.append(line);
                    }
                   return result.toString().replace("/N/", System.getProperty("line.separator")); // /N/ on php makes a new line at the textview
                   // return result.toString(); // normal response without new lines
                } else {
                    return "Fail (" + responseCode + ")";
                }
            } catch (IOException e) {
                return "Unable to connect";
            }
        }

        @Override
        protected void onPostExecute(String result) {
            TextView view_result = (TextView) findViewById(R.id.textView);
            view_result.setText(result);
        }
    }
}


